#! /bin/sh
# Convert Life Lexicon to HTML and find missing anchor targets

# define input and output file name
input=lexicon.txt
output=lexicon.html

# define link targets and anchors
targets=targets.txt
anchors=anchors.txt

# define list of missing targets
missing=missing.txt

# build the targets list
cat $input | sed -ne 's@^:\([^:]*\):.*@\1@p' > $targets

# build the anchors list
cat $input | sed -ne 's@{\([^}]*\)}@\n\@\1\n@gp' | sed -ne '/^@/p' | sed -e 's/@//' > $anchors

# build the list of unmatched links
grep -v -x -F -f $targets $anchors | sort -u > $missing

# write HTML header
cat << _END > $output
<!DOCTYPE html>
<html>
        <head>
                <meta charset="UTF-8">
                <title>Life Lexicon</title>
        </head>
        <body>
<div>
<p>
_END

# convert lexicon to HTML
cat $input | sed "s@^:\([^:]*\):@</p></div><div id='\1'><h2>\1</h2><p>@;s@{\([^}]*\)}@<a href='#\1'>\1</a>@g" >> $output

# write HTML footer
cat << _END >> $output
        </body>
</html>
_END
